/*******************************************************************************

 WINBINDER - A native Windows binding for PHP

 Copyright  2004 Hypervisual - see LICENSE.TXT for details
 Author: Rubem Pechansky (pechansky@hypervisual.com)

 ZEND wrapper for drawing functions

*******************************************************************************/

//----------------------------------------------------------------- DEPENDENCIES

#include "phpwb.h"

//----------------------------------------------------------- EXPORTED FUNCTIONS

/*

int wb_get_pixel ( int source, int x, int y)

source can be:
	- a bitmap handle
	- a window handle
	- an DC

Returns NOCOLOR (-1) if error

TODO: handle could also be a bitmap file

*/

ZEND_FUNCTION(wb_get_pixel)
{
    long handle, x, y;

    if(zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,
	  "lll", &handle, &x, &y) == FAILURE)
		return;

	RETURN_LONG(wbGetPixel((HANDLE)handle, x, y));
}

/*

TODO: allow separate R,G,B values
TODO: handle could also be a bitmap file??

*/

ZEND_FUNCTION(wb_set_pixel)
{
    long handle, x, y, c;

    if(zend_parse_parameters(ZEND_NUM_ARGS() TSRMLS_CC,
	  "llll", &handle, &x, &y, &c) == FAILURE)
		return;

	RETURN_BOOL(wbSetPixel((HANDLE)handle, x, y, c));
}

//------------------------------------------------------------------ END OF FILE
